<template>
  <div class="form-without-border">
    <div class="container">
      <div class="row">
        <div class="col">
          <span> {{ $t('email-project') }} : {{ emailAccountService }} </span>
          <br>
          <label>{{ $t('sheet-url') }} * </label>
          <select @change="getSheetsName" class="form-control" v-model="form.sheetId">
            <option v-bind:key="item.value" v-for="item in allSheets" v-bind:value="item.value">{{ item.label }}</option>
          </select>
        </div>
        <div class="col top">
          <label>{{ $t('sheet-name') }} *</label>
          <select class="form-select form-control" v-model="form.sheetName">
            <option
              v-for="item in sheets"
              :selected="item"
              :key="item"
              :value="item"
            >{{item}}</option>
          </select>
        </div>
        <div class="col top">
          <label>{{ $t('tag-template-id') }} *</label>
          <select class="form-control" v-model="form.tagTemplateId">
            <option v-bind:key="item.id" v-for="item in optTagModel" v-bind:value="item.id">{{ item.libelle }}</option>
          </select>
        </div>
        <button v-show="isForInsert" @click="insertTag" class="btn btn-outline-success col-xs">{{ $t('send') }}</button>
        <button v-show="!isForInsert" @click="writeTagTemplateOnSheet" class="btn btn-outline-primary col-xs">{{ $t('sheet-write-template') }}</button>
        <button v-show="!isForInsert" @click="writeAllTagsOnSheet" class="btn btn-outline-primary col-xs">{{ $t('sheet-write-data') }}</button>
        <button @click="resetForm" class="btn btn-outline-secondary col-xs">{{ $t('reset') }} </button>
      </div>
    </div>
  </div>
</template>

<script>
import APISheet from '@/api/sheet'
import APIWrite from '@/api/write'
import APIGcp from '@/api/gcp'
import APInsert from '@/api/insert'
import APICredentials from '@/api/credentials'
import Vue from 'vue'
import custom from '@/shared/custom'
export default {
  props: {
    isForInsert: {
      type: Boolean
    }
  },
  data () {
    return {
      allSheets: null,
      loading: false,
      loadTagTemplate: false,
      form: {
        sheetId: null,
        sheetName: null,
        tagTemplateId: null
      },
      sheets: null,
      optTagModel: null,
      emailAccountService: null
    }
  },
  methods: {
    addAllToList (list) {
      list.unshift({
        id: '*',
        libelle: this.$t('all'),
        disponible: true
      })
      return list
    },
    filterListByDispo (list) {
      if (list) {
        return list.filter(item => item.disponible === true)
      } else {
        return null
      }
    },
    getAllSheet () {
      const allSheets = []
      APISheet.getAllSheet().then(allSheet => {
        allSheet.forEach(item => {
          allSheets.push({
            value: item.id,
            label: item.name
          })
        })
        this.allSheets = allSheets
        Vue.prototype.$allSheets = allSheets
        this.$store.commit('saveLoading', false)
      })
    },
    getAllTagModels () {
      const optTagModel = []
      APIGcp.getTagModelsWithoutProjectName().then(response => {
        response.forEach(item => {
          optTagModel.push({
            id: item.id,
            libelle: item.libelle,
            disponible: item.disponible
          })
        })
        Vue.prototype.$optTagModel = this.addAllToList(optTagModel)
        this.optTagModel = this.filterListByDispo(optTagModel).slice(1)
        this.$store.commit('saveLoading', false)
      })
    },
    getSheetsName () {
      this.$store.commit('saveLoading', true)
      Vue.prototype.$form = this.form
      APISheet.getSheetsName(this.form).then(response => {
        Vue.prototype.$response = response
        this.sheets = response
        this.$store.commit('saveLoading', false)
      }).catch(() => {
        this.$store.commit('saveLoading', false)
        this.$alert(this.$t('error-occurred'), this.$t('error'), 'error')
      })
    },
    insertTag () {
      if (this.checkEmptyField()) {
        this.$alert(this.$t('empty-field'), this.$t('warning'), 'warning')
      } else {
        this.$store.commit('saveLoading', true)
        Vue.prototype.$form = this.form
        APInsert.insertTagsFromSheet(this.form).then(response => {
          Vue.prototype.$response = response
          this.$store.commit('saveLoading', false)
          this.$router.push('/results')
        }).catch(() => {
          this.$store.commit('saveLoading', false)
          this.$alert(this.$t('error-occurred'), this.$t('error'), 'error')
        })
      }
    },
    writeAllTagsOnSheet () {
      if (this.checkEmptyField()) {
        this.$alert(this.$t('empty-field'), this.$t('warning'), 'warning')
      } else {
        this.$store.commit('saveLoading', true)
        APIWrite.writeAllTagsOnSheet(this.form).then(response => {
          this.$store.commit('saveLoading', false)
          this.$alert(this.$t('write-sheet'), this.$t('success'), 'success')
        }).catch(() => {
          this.$store.commit('saveLoading', false)
          this.$alert(this.$t('error-occurred'), this.$t('error'), 'error')
        })
      }
    },
    writeTagTemplateOnSheet () {
      if (this.checkEmptyField()) {
        this.$alert(this.$t('empty-field'), this.$t('warning'), 'warning')
      } else {
        this.$store.commit('saveLoading', true)
        APIWrite.writeTagTemplateOnSheet(this.form).then(response => {
          this.$store.commit('saveLoading', false)
          this.$alert(this.$t('write-sheet'), this.$t('success'), 'success')
        }).catch(() => {
          this.$store.commit('saveLoading', false)
          this.$alert(this.$t('error-occurred'), this.$t('error'), 'error')
        })
      }
    },
    checkEmptyField () {
      let isEmpty = false
      for (var field in this.form) {
        if (!this.form[field]) {
          isEmpty = true
          break
        }
      }
      return isEmpty
    },
    resetForm () {
      for (var field in this.form) {
        this.form[field] = null
      }
    },
    initForm () {
      if (this.$form) {
        this.form = this.$form
        this.getSheetsName()
      }
    },
    getLoadedFilters () {
      this.allSheets = this.$allSheets
      if (this.$optTagModel) {
        this.optTagModel = this.filterListByDispo(this.$optTagModel).slice(1)
      } else {
        this.optTagModel = null
      }
      const isAllLoad = (this.optTagModel && this.allSheets)
      if (!isAllLoad) {
        if (!this.optTagModel) {
          this.getAllTagModels()
        }
        if (!this.allSheets) {
          this.getAllSheet()
        }
      } else {
        this.$store.commit('saveLoading', false)
      }
    }
  },
  mounted () {
    custom.getGoodItemAndColorIt(this.$route.path)
    this.$store.commit('saveLoading', true)
    this.initForm()
    this.getLoadedFilters()
    if (!this.$emailAccountService) {
      APICredentials.getEmailServiceAccount().then(email => {
        this.emailAccountService = email
        Vue.prototype.$emailAccountService = email
      })
    } else {
      this.emailAccountService = this.$emailAccountService
    }
  }
}
</script>

<style scoped>
.form-without-border {
  margin: 30px 2% 0 7%;
  padding-bottom: 20px;
}
.center {
  text-align: center;
}
.btn {
  margin-top: auto;
  margin-right: 15px;
}
.top {
  margin-top: auto;
}
.container {
  padding: 0;
  margin: 0;
  width: 100%;
  max-width: 100%;
}
label {
  margin: 0;
}
span {
  font-size: 12px;
  color: rgba(9,30,66,0.5);
  font-style: italic;
}
</style>
